import * as raw from './raw';
// Base URL
const getManyUrl = params => `/organizations/${params.organizationId}/app_definitions/${params.appDefinitionId}/functions`;
const getFunctionUrl = params => `${getManyUrl(params)}/${params.functionId}`;
const getFunctionsEnvURL = params => {
  return `/spaces/${params.spaceId}/environments/${params.environmentId}/app_installations/${params.appInstallationId}/functions`;
};
export const get = (http, params) => {
  return raw.get(http, getFunctionUrl(params));
};
export const getMany = (http, params) => {
  return raw.get(http, getManyUrl(params), {
    params: params.query
  });
};
export const getManyForEnvironment = (http, params) => {
  return raw.get(http, getFunctionsEnvURL(params), {
    params: params.query
  });
};