import { freezeSys, toPlainObject } from 'contentful-sdk-core';
import copy from 'fast-copy';
import { wrapCursorPaginatedCollection } from '../common-utils';
import { createEnvironmentTemplateApi } from '../create-environment-template-api';
import enhanceWithMethods from '../enhance-with-methods';
export function wrapEnvironmentTemplate(makeRequest, data, organizationId) {
  const environmentTemplate = toPlainObject(copy(data));
  const environmentTemplateApi = createEnvironmentTemplateApi(makeRequest, organizationId);
  const enhancedEnvironmentTemplate = enhanceWithMethods(environmentTemplate, environmentTemplateApi);
  return freezeSys(enhancedEnvironmentTemplate);
}
export const wrapEnvironmentTemplateCollection = wrapCursorPaginatedCollection(wrapEnvironmentTemplate);