import { pollAsyncActionStatus } from './action';
/** Waits for a BulkAction status to be either succeeded or failed.
 * Used by the Plain client */
export async function waitForBulkActionProcessing({
  plainClient,
  spaceId,
  environmentId,
  bulkActionId
}, options) {
  return pollAsyncActionStatus(async () => plainClient.bulkAction.get({
    bulkActionId,
    spaceId,
    environmentId
  }), options);
}