import { pollAsyncActionStatus } from './action';
/** Waits for a ReleaseAction status to be either succeeded or failed.
 * Used by the Plain client */
export async function waitForReleaseActionProcessing({
  plainClient,
  spaceId,
  environmentId,
  releaseId,
  actionId
}, options) {
  return pollAsyncActionStatus(async () => plainClient.releaseAction.get({
    releaseId,
    spaceId,
    environmentId,
    actionId
  }), options);
}