import type { RawAxiosRequestHeaders } from 'axios';
import type { AxiosInstance } from 'contentful-sdk-core';
import type { GetWebhookParams } from '../../../common-types';
import type { CreateWebhooksProps, WebhookProps } from '../../../entities/webhook';
import type { RestEndpoint } from '../types';
export declare const get: RestEndpoint<'Webhook', 'get'>;
export declare const getManyCallDetails: RestEndpoint<'Webhook', 'getManyCallDetails'>;
export declare const getCallDetails: RestEndpoint<'Webhook', 'getCallDetails'>;
export declare const getHealthStatus: RestEndpoint<'Webhook', 'getHealthStatus'>;
export declare const getMany: RestEndpoint<'Webhook', 'getMany'>;
export declare const getSigningSecret: RestEndpoint<'Webhook', 'getSigningSecret'>;
/**
 * @deprecated The EAP for this feature has ended. This method will be removed in the next major version.
 */
export declare const getRetryPolicy: RestEndpoint<'Webhook', 'getRetryPolicy'>;
export declare const create: RestEndpoint<'Webhook', 'create'>;
export declare const createWithId: (http: AxiosInstance, params: GetWebhookParams, rawData: CreateWebhooksProps, headers?: RawAxiosRequestHeaders) => Promise<WebhookProps>;
export declare const update: RestEndpoint<'Webhook', 'update'>;
export declare const upsertSigningSecret: RestEndpoint<'Webhook', 'upsertSigningSecret'>;
/**
 * @deprecated The EAP for this feature has ended. This method will be removed in the next major version.
 */
export declare const upsertRetryPolicy: RestEndpoint<'Webhook', 'upsertRetryPolicy'>;
export declare const del: RestEndpoint<'Webhook', 'delete'>;
export declare const deleteSigningSecret: RestEndpoint<'Webhook', 'deleteSigningSecret'>;
/**
 * @deprecated The EAP for this feature has ended. This method will be removed in the next major version.
 */
export declare const deleteRetryPolicy: RestEndpoint<'Webhook', 'deleteRetryPolicy'>;
